/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, E_SFmode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !arith_operand32 (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!arith_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  operands[4] = x6;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  operands[5] = x7;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  operands[6] = x8;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  operands[7] = x9;
  if (!const_int_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, E_SFmode) != 0
              || !
#line 416 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 5; /* mulsf3 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !arith_operand (operands[2], E_SImode)
              || !
#line 551 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL))
            return -1;
          return 15; /* mulsi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 565 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
        return -1;
      return 16; /* mulsidi3 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 576 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
            return -1;
          return 17; /* umulsidi3 */

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 587 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
            return -1;
          return 18; /* usmulsidi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LSHIFTRT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x8) != SIGN_EXTEND)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 600 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
        return -1;
      return 19; /* *smulsi3_highpart */

    case ZERO_EXTEND:
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 614 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
            return -1;
          return 20; /* *umulsi3_highpart */

        case SIGN_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 628 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL && TARGET_MULTIPLY_HIGH))
            return -1;
          return 21; /* *usmulsi3_highpart */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 31; /* zero_extendhisi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 33; /* zero_extendqisi2 */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 32; /* zero_extendqihi2 */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34; /* extendqisi2 */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35; /* extendhisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 36; /* extendsidi2 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_SImode))
        {
          x4 = XEXP (x3, 1);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x5 = XEXP (x1, 0);
              if (GET_CODE (x5) == PC)
                {
                  x6 = XEXP (x3, 0);
                  operands[1] = x6;
                  if (register_operand (operands[1], E_SImode))
                    {
                      x7 = XEXP (x2, 1);
                      operands[2] = x7;
                      if (pc_or_label_operand (operands[2], E_SImode))
                        {
                          x8 = XEXP (x2, 2);
                          operands[3] = x8;
                          if (pc_or_label_operand (operands[3], E_SImode))
                            return 66; /* branch_zero */
                        }
                    }
                }
            }
        }
      if (pnum_clobbers == NULL
          || !cmp_op (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[3] = x9;
      *pnum_clobbers = 1;
      return 67; /* branch_compare */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode)
              && 
#line 365 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
            return 1; /* bswapsi2 */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode
              && register_operand (operands[1], E_HImode)
              && 
#line 372 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
            return 2; /* bswaphi2 */
          break;

        default:
          break;
        }
      break;

    case PLUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (
#line 396 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 3; /* addsf3 */
          break;

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && arith_plus_operand (operands[2], E_SImode))
            return 10; /* addsi3 */
          break;

        case 2:
          return 11; /* adddi3 */

        default:
          break;
        }
      break;

    case MINUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (
#line 406 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 4; /* subsf3 */
          break;

        case 1:
          if (arith_operand (operands[1], E_SImode)
              && arith_operand (operands[2], E_SImode))
            return 12; /* subsi3 */
          break;

        case 2:
          return 14; /* subdi3 */

        default:
          break;
        }
      break;

    case MULT:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x2, E_SFmode) == 0
              && 
#line 427 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 6; /* divsf3 */
          break;

        case E_SImode:
          if (pattern0 (x2, E_SImode) == 0
              && 
#line 664 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_DIV))
            return 22; /* divsi3_internal */
          break;

        default:
          break;
        }
      break;

    case SQRT:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SFmode)
                  && 
#line 436 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_SQRT))
                return 7; /* sqrtsf2 */
            }
        }
      break;

    case FLOAT:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode)
                  && 
#line 445 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_CONVERT))
                return 8; /* floatsisf2 */
            }
        }
      break;

    case FIX:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SFmode)
                  && 
#line 454 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_CONVERT))
                return 9; /* fix_truncsfsi2 */
            }
        }
      break;

    case TRUNCATE:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UDIV:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode)
                      && 
#line 676 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_DIV))
                    return 23; /* udivsi3 */
                }
            }
        }
      break;

    case NEG:
      switch (pattern2 (x1))
        {
        case 0:
          return 24; /* negsi2 */

        case 1:
          return 25; /* negdi2 */

        default:
          break;
        }
      break;

    case NOT:
      switch (pattern2 (x1))
        {
        case 0:
          return 26; /* one_cmplsi2 */

        case 1:
          return 27; /* *one_cmpldi2 */

        default:
          break;
        }
      break;

    case AND:
      if (pattern3 (x1) == 0)
        return 28; /* andsi3 */
      break;

    case IOR:
      if (pattern3 (x1) == 0)
        return 29; /* iorsi3 */
      break;

    case XOR:
      if (pattern3 (x1) == 0)
        return 30; /* xorsi3 */
      break;

    case ZERO_EXTEND:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && general_operand (operands[1], E_DImode))
                return 37; /* *movdi_internal */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && register_operand (operands[1], E_SImode)
                  && 
#line 1006 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(microblaze_is_interrupt_variant ()))
                return 38; /* movsi_status */
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && 
#line 1019 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], SImode) && 
           (GET_CODE (operands[1]) == CONST_INT && 
                 (INTVAL (operands[1]) <= 32767 && INTVAL (operands[1]) >= -32768)))))
                return 39; /* *movsi_internal3 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && general_operand (operands[1], E_HImode))
                return 42; /* *movhi_internal2 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && general_operand (operands[1], E_QImode))
                return 43; /* *movqi_internal2 */
              break;

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && general_operand (operands[1], E_SFmode)
                  && 
#line 1199 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode)
       || operands[1] == CONST0_RTX (SFmode))))
                return 45; /* *movsf_internal */
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && general_operand (operands[1], E_DFmode))
                return 46; /* *movdf_internal */
              break;

            default:
              break;
            }
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 69; /* indirect_jump_internal1 */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == LABEL_REF
          && GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 68; /* jump */
        }
      break;

    case IF_THEN_ELSE:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  operands[1] = x2;
  if (call_insn_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode)
      && 
#line 1034 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], Pmode) && 
           PLT_ADDR_P (operands[1]))))
    return 40; /* *movsi_internal5_pltop */
  if (move_src_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_SImode))
    return 41; /* *movsi_internal2 */
  switch (GET_CODE (x2))
    {
    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || !reg_or_mem_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_mem_operand (operands[1], E_SFmode)
          || !
#line 1166 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
        return -1;
      return 44; /* movsi4_rev */

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1326 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 47; /* *ashlsi3_byone */
          if (
#line 1338 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 48; /* ashlsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        {
          if (
#line 1353 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL 
   && ((1 << INTVAL (operands[2])) <= 32767 && (1 << INTVAL (operands[2])) >= -32768)))
            return 49; /* *ashlsi3_with_mul_delay */
          if (
#line 1366 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL))
            return 50; /* *ashlsi3_with_mul_nodelay */
          if (
#line 1378 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((INTVAL (operands[2]) > 5 && optimize_size)))
            return 51; /* *ashlsi3_with_size_opt */
          if (
#line 1399 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((INTVAL (operands[2]) > 17 && !optimize_size)))
            return 52; /* *ashlsi3_with_rotate */
          return 53; /* *ashlsi_inline */
        }
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 54; /* *ashlsi_reg */

    case ASHIFTRT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1487 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 55; /* *ashrsi3_byone */
          if (
#line 1499 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 56; /* *ashrsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        return 57; /* *ashrsi_inline */
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 58; /* *ashrsi_reg */

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1576 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 59; /* *lshrsi3_byone */
          if (
#line 1588 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 60; /* *lshrsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        return 61; /* *lshrsi_inline */
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 62; /* *lshrsi_reg */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode))
                {
                  switch (GET_CODE (x2))
                    {
                    case EQ:
                      if (
#line 1659 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_PATTERN_COMPARE))
                        return 63; /* seq_internal_pat */
                      break;

                    case NE:
                      if (
#line 1671 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_PATTERN_COMPARE))
                        return 64; /* sne_internal_pat */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      operands[1] = x2;
      if (!ordered_comparison_operator (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_SFmode)
          || !
#line 1686 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 65; /* cstoresf4 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 101:
          return 83; /* set_got */

        case 107:
          return 84; /* set_text */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2339 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HAS_CLZ))
        return -1;
      return 85; /* clzsi2 */

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_6 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case UNSPEC:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 0)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != E_BLKmode)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != SCRATCH)
                return -1;
              x6 = XVECEXP (x2, 0, 0);
              operands[0] = x6;
              if (!const_int_operand (operands[0], E_SImode)
                  || !
#line 519 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_PREFETCH))
                return -1;
              return 13; /* iprefetch */

            case SET:
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case IF_THEN_ELSE:
                  x8 = XEXP (x7, 0);
                  if (!cmp_op (x8, E_SImode))
                    return -1;
                  operands[0] = x8;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != LABEL_REF)
                    return -1;
                  x10 = XEXP (x7, 2);
                  if (GET_CODE (x10) != PC
                      || pattern4 (x1, 18, PC) != 0)
                    return -1;
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x12 = XEXP (x8, 1);
                  operands[2] = x12;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  operands[3] = x13;
                  return 67; /* branch_compare */

                case REG:
                case SUBREG:
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x14 = XEXP (x2, 0);
                  if (GET_CODE (x14) != PC)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != USE)
                    return -1;
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != LABEL_REF)
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  return 70; /* tablejump_internal1 */

                case PLUS:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != LABEL_REF
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x14 = XEXP (x2, 0);
                  if (GET_CODE (x14) != PC)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != USE)
                    return -1;
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != LABEL_REF
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  operands[1] = x13;
                  x5 = XEXP (x4, 0);
                  if (!rtx_equal_p (x5, operands[1])
                      || !
#line 1886 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(NEXT_INSN (as_a <rtx_insn *> (operands[1])) != 0
  && GET_CODE (PATTERN (NEXT_INSN (as_a <rtx_insn *> (operands[1])))) == ADDR_DIFF_VEC
  && flag_pic))
                    return -1;
                  return 71; /* *microblaze.md:1881 */

                case CALL:
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != MEM)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != CLOBBER)
                    return -1;
                  x14 = XEXP (x2, 0);
                  operands[0] = x14;
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (!call_insn_operand (operands[1], E_VOIDmode))
                    return -1;
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  x4 = XEXP (x3, 0);
                  operands[3] = x4;
                  if (!register_operand (operands[3], E_SImode))
                    return -1;
                  return 80; /* call_value_intern */

                default:
                  return -1;
                }

            case RETURN:
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != USE)
                return -1;
              x4 = XEXP (x3, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 74; /* return_internal */

            case SIMPLE_RETURN:
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != USE)
                return -1;
              x4 = XEXP (x3, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 75; /* simple_return_internal */

            case CALL:
              if (pattern4 (x1, 15, MEM) != 0)
                return -1;
              x14 = XEXP (x2, 0);
              x15 = XEXP (x14, 0);
              operands[0] = x15;
              if (!call_insn_simple_operand (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              return 78; /* call_internal1 */

            default:
              return -1;
            }

        case 3:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != USE)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x14 = XEXP (x2, 0);
              if (GET_CODE (x14) != MEM)
                return -1;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 15
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 20
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[0] = x15;
              if (!call_insn_plt_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (!
#line 2108 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(flag_pic))
                return -1;
              return 77; /* call_internal_plt */

            case SET:
              x7 = XEXP (x2, 1);
              if (GET_CODE (x7) != CALL)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != MEM)
                return -1;
              x14 = XEXP (x2, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!call_insn_plt_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 1);
              operands[2] = x9;
              x4 = XEXP (x3, 0);
              operands[3] = x4;
              if (!register_operand (operands[3], E_SImode))
                return -1;
              x17 = XEXP (x16, 0);
              operands[4] = x17;
              if (!register_operand (operands[4], E_SImode)
                  || !
#line 2217 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(flag_pic))
                return -1;
              return 79; /* call_value_intern_plt */

            default:
              return -1;
            }

        case 9:
          x18 = XVECEXP (x1, 0, 8);
          if (GET_CODE (x18) != CLOBBER
              || pattern5 (x1) != 0)
            return -1;
          x19 = XEXP (x18, 0);
          operands[8] = x19;
          if (!scratch_operand (operands[8], E_SImode))
            return -1;
          return 86; /* atomic_compare_and_swapsi */

        case 8:
          if (pnum_clobbers == NULL
              || pattern5 (x1) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 86; /* atomic_compare_and_swapsi */

        default:
          return -1;
        }

    case RETURN:
      return 72; /* *return */

    case SIMPLE_RETURN:
      return 73; /* *simple_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 76; /* blockage */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x20 = XEXP (x1, 0);
      if (GET_CODE (x20) != MEM)
        return -1;
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!call_insn_simple_operand (operands[0], E_VOIDmode))
        return -1;
      x22 = XEXP (x1, 1);
      operands[1] = x22;
      *pnum_clobbers = 1;
      return 78; /* call_internal1 */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 81; /* nop */

    case TRAP_IF:
      x20 = XEXP (x1, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x1, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 82; /* trap */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 753 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(reload_completed 
   && GET_CODE (operands[0]) == REG && GP_REG_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && GP_REG_P (REGNO (operands[1]))))
        return NULL;
      return gen_split_1 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode))
            return NULL;
          if (
#line 968 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(reload_completed 
   && GET_CODE (operands[0]) == REG && GP_REG_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && GP_REG_P (REGNO (operands[1])) 
   && (REGNO(operands[0]) == (REGNO(operands[1]) + 1))))
            return gen_split_2 (insn, operands);
          if (!
#line 980 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(reload_completed 
   && GET_CODE (operands[0]) == REG && GP_REG_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && GP_REG_P (REGNO (operands[1])) 
   && (REGNO (operands[0]) != (REGNO (operands[1]) + 1))))
            return NULL;
          return gen_split_3 (insn, operands);

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode))
            return NULL;
          if (
#line 1279 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && GP_REG_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && GP_REG_P (REGNO (operands[1]))
   && (REGNO (operands[0]) == (REGNO (operands[1]) + 1))))
            return gen_split_4 (insn, operands);
          if (!
#line 1290 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && GP_REG_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && GP_REG_P (REGNO (operands[1]))
   && (REGNO (operands[0]) != (REGNO (operands[1]) + 1))))
            return NULL;
          return gen_split_5 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != FIX
      || GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SFmode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return NULL;
  x7 = XEXP (x6, 0);
  if (!ordered_comparison_operator (x7, E_VOIDmode))
    return NULL;
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != LABEL_REF)
    return NULL;
  x9 = XEXP (x6, 2);
  if (GET_CODE (x9) != PC)
    return NULL;
  x10 = XEXP (x5, 0);
  if (GET_CODE (x10) != PC)
    return NULL;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return NULL;
  x12 = XEXP (x7, 1);
  operands[4] = x12;
  if (!arith_operand (operands[4], E_SImode))
    return NULL;
  x13 = XEXP (x8, 0);
  operands[5] = x13;
  if (!
#line 691 "../../gcc-14.1.1-20240508/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_1 (insn, operands);
}
